﻿// Code generated by Microsoft (R) AutoRest Code Generator 0.9.7.0
// Changes may cause incorrect behavior and will be lost if the code is regenerated.

using System;
using System.Linq;
using Newtonsoft.Json.Linq;

namespace Microsoft.Bot.Builder.Luis
{
    /// <summary>   LUIS intent recommendation. </summary>
    public partial class IntentRecommendation
    {
        private string _intent;

        /// <summary>
        /// The intent returned from LUIS.
        /// </summary>
        /// <remarks>An intent is required in this class.</remarks>
        public string Intent
        {
            get { return this._intent; }
            set { this._intent = value; }
        }

        private double? _score;

        /// <summary>
        /// LUIS confidence score.
        /// </summary>
        /// <remarks>The confidence score is optional.</remarks>
        public double? Score
        {
            get { return this._score; }
            set { this._score = value; }
        }

        /// <summary>
        /// Constructor.
        /// </summary>
        public IntentRecommendation()
        {
        }

        /// <summary>
        /// Contructor with required intent.
        /// </summary>
        /// <param name="intent">Intent form LUIS.</param>
        public IntentRecommendation(string intent)
            : this()
        {
            if (intent == null)
            {
                throw new ArgumentNullException("intent");
            }
            this.Intent = intent;
        }

        /// <summary>
        /// Deserialize the object from LUIS.
        /// </summary>
        /// <param name="inputObject">JSON response from LUIS.</param>
        public virtual void DeserializeJson(JToken inputObject)
        {
            if (inputObject != null && inputObject.Type != JTokenType.Null)
            {
                JToken intentValue = inputObject["Intent"];
                if (intentValue != null && intentValue.Type != JTokenType.Null)
                {
                    this.Intent = ((string)intentValue);
                }
                JToken scoreValue = inputObject["Score"];
                if (scoreValue != null && scoreValue.Type != JTokenType.Null)
                {
                    this.Score = ((double)scoreValue);
                }
            }
        }

        /// <summary>
        /// Serialize this intent.
        /// </summary>
        /// <param name="outputObject">Result of serialization.</param>
        /// <returns>
        /// Returns the json model for the type IntentRecommendation
        /// </returns>
        public virtual JToken SerializeJson(JToken outputObject)
        {
            if (outputObject == null)
            {
                outputObject = new JObject();
            }
            if (this.Intent == null)
            {
                throw new ArgumentNullException("Intent");
            }
            if (this.Intent != null)
            {
                outputObject["Intent"] = this.Intent;
            }
            if (this.Score != null)
            {
                outputObject["Score"] = this.Score.Value;
            }
            return outputObject;
        }
    }
}
